program MajopsSkeletonScriptPascal;
uses crt, SysUtils;

(* Global variables *)

var
	g_exampleVariable: string; (* Only, if this is necessary. *)
	
procedure showUsageInformation();
begin
	writeln();
	writeln('Majops Skeleton Script Pascal is the base for making new scripts in Pascal.');
	writeln('For this Majops Skeleton Script Pascal, an executable file has to be made first.');
	writeln('Therefore, it has to be compiled by typing:');
	writeln();
	writeln('fpc [Pascal script file name with .pas extension]');
	writeln();
	writeln('Next to that executable file, a text file with .o extension is made.');
	writeln();
	writeln('The generated executable file can be started by typing:');
	writeln();
	writeln('./[Pascal script file name without any extension]');
	writeln(); 
	writeln('To generate an executable file for this Majops Skeleton Script Pascal, you have to type:');
	writeln();
	writeln('fpc MajopsSkeletonScriptPascal.pas');
	writeln();
	writeln('Next to it, text file MajopsSkeletonScriptPascal.o is made.');
	writeln();
	writeln('To start the generated executable file for this Majops Skeleton Script Pascal, you have to type:');
	writeln();
	writeln('./MajopsSkeletonScriptPascal');
	writeln();	
	writeln('The user has to type here what the Pascal script can perform and does.');
	writeln();
	writeln('Way of usage:');
	writeln();
	writeln('The user has to type here how he has to work with the Pascal script and');
	writeln('how the command line arguments are used.');
	writeln();
	writeln('Example:');
	writeln();
	writeln('fpc MajopsSkeletonScriptPascal.pas');
	writeln('./MajopsSkeletonScriptPascal input1.txt input2.csv 10 output.csv');
	writeln();
	
	Halt;
end;

(* From here till the main procedure, functions and/or procedures have to be programmed. *) 
(* An example procedure: showHelloWorld. *)
procedure showHelloWorld(helloWorld: string);
begin
	writeln();
	writeln(helloWorld);
	writeln();
	writeln(g_exampleVariable);
	writeln();
end;

(* The last procedure is always the main procedure, in which only other functions and/or procedures are called. *)
procedure main();
var
		helloToUser: string;
begin		
	if (ParamCount >= 1) then
	begin
		if	(CompareText(ParamStr(1), '-h') = 0) or (CompareText(ParamStr(1), '--h') = 0) or 
			(CompareText(ParamStr(1), '-help') = 0) or (CompareText(ParamStr(1), '--help') = 0) then 
		begin
			showUsageInformation();
		end;
	end;
	
	helloToUser := 'Hello World!';
	
	showHelloWorld(helloToUser); (* Example of a procedure. *)
end;

begin
	g_exampleVariable := 'Global Example Variable'; (* Only, if this is necessary. *)
	main();
end.

(* Additional information: *)
(* ======================= *)
(* *)
(* Remarks about the Majops Skeleton Script Pascal itself. *)
(* Description how it works. *)
(* Description which improvements can be done to improve the Majops Skeleton Script Pascal itself. *)
(* *)
